import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

public abstract class Dummy
{
  protected Object schuelerObjekt;
  private Class[] interfaces;
  private Map<String, Method> methoden = new HashMap();
  
  protected Dummy(Object objekt)
  {
    this.schuelerObjekt = objekt;
    this.interfaces = getClass().getInterfaces();
    
    MethodenAbgleichen();
  }
  
  private void MethodenAbgleichen()
  {
    for (int i = 0; i < this.interfaces.length; i++)
    {
      Method[] interfaceMet = this.interfaces[i].getDeclaredMethods();
      for (int j = 0; j < interfaceMet.length; j++) {
        MethodePruefen(interfaceMet[j].getName());
      }
    }
  }
  
  protected boolean MethodePruefen(String interfaceMetName)
  {
    Method[] schuelerMet = this.schuelerObjekt.getClass().getDeclaredMethods();
    boolean match = false;
    for (int i = 0; i < schuelerMet.length; i++) {
      if (schuelerMet[i].getName().equalsIgnoreCase(interfaceMetName))
      {
        this.methoden.put(interfaceMetName, schuelerMet[i]);
        MethodenNameSetzen(interfaceMetName);
        
        match = true;
      }
    }
    return match;
  }
  
  protected Object MethodeAufrufen(String name, Object[] args, Object schuelerObject)
    throws MethodeNichtImplementiertException
  {
    Object o = null;
    if (this.methoden.containsKey(name)) {
      try
      {
        o = ((Method)this.methoden.get(name)).invoke(schuelerObject, args);
      }
      catch (Exception e)
      {
        e.printStackTrace();
        throw new MethodeNichtImplementiertException("Beim Methodenaufruf der Methode " + name + 
          " auf " + schuelerObject.getClass().getName() + "ist ein Fehler aufgetreten");
      }
    } else {
      throw new MethodeNichtImplementiertException("Die Methode " + name + 
        " die das Objekt " + schuelerObject.getClass().getName() + " haben sollte wurde vom Schueler nicht implementiert!");
    }
    return o;
  }
  
  protected boolean MethodenNameSetzen(String name)
  {
    return false;
  }
}
